#include "db_dual.h"
//
/*  Save file as db_dual.cpp  */
/*  incomming class name DB_dual */
//



DNS_model::DNS_model( const QSqlDatabase dbin , const QString domaine )
{
    db = dbin;
    waitremoval = 0;
    host = domaine;
    setTable("DNSEntry");
    setEditStrategy(QSqlTableModel::OnRowChange);
    refresh();
}

void DNS_model::VertikalRow( int line )
{
    /* qPrintable(tips) */
    ////////////QModelIndex primaryKeyIndex = QSqlQueryModel::index(line,0);
    //////////int id = data(primaryKeyIndex).toInt();
    ///////////waitremoval = id;
    ////////////TContext = new QMenu();
    ///////////TContext->addAction(tr( "Remove entry nr. %1" ).arg(id), this , SLOT(ReMoveLine()));
    ////////TContext->addAction(tr( "Append entry" ), this , SLOT(AppenEntry()));
    /////TContext->addAction(tr( "Reload table entry from %1" ).arg(host), this , SLOT(refresh()));
    //////////TContext->addAction(tr( "Close context" ), this , SLOT(Coclose()));
    /////////TContext->exec(QCursor::pos());
    
    /////////TContext->deleteLater();
}

void DNS_model::Coclose()
{

}

void DNS_model::ReMoveLine()
{
    if (waitremoval > 0) {
        std::cout << "order remove  " << waitremoval << std::endl; 
         QString updateop = QString("DELETE FROM DNSEntry WHERE id = '%1'").arg(waitremoval);
         QSqlQuery query(db);
         bool fatt = query.exec(updateop);
         refresh();
         waitremoval = 0;
         if (!fatt) {
         return;
         }
    }
    
    waitremoval = 0;
    //////Coclose();
    refresh();
}


void DNS_model::AppenEntry()
{
    ////Coclose();
    emit NewRow();
    refresh();
}


Qt::ItemFlags DNS_model::flags( const QModelIndex &index) const
{
    Qt::ItemFlags flags = QSqlQueryModel::flags(index);
    if ( index.column() == 1) {
        flags |=  Qt::ItemIsEnabled;
    } else {
        flags |= Qt::ItemIsEditable;
    }
    return flags;
}


bool DNS_model::ValidIP( QString ipadress )
{
      QStringList slist = ipadress.split(".");
      int s = slist.size();
      if (s >4) {
      return false;
      }
      for(int i=0;i<s;i++){
        bool ok;
        int val = slist[i].toInt(&ok);
        if(!ok || val<0 || val>255) return false;
      }
      return true;
}



bool DNS_model::setData(const QModelIndex &index, const QVariant &value, int  role )
{
    if ( index.column() == 1) {
        return false;
    }
    QModelIndex primaryKeyIndex = QSqlQueryModel::index(index.row(), 0);
    QModelIndex tipeKey = QSqlQueryModel::index(index.row(), 2);
    const QString tips = data(tipeKey).toString().toUpper();
    int id = data(primaryKeyIndex).toInt();
    
    ////////std::cout << "TIPEACTUAL  " << qPrintable(tips) << std::endl; 
    
    bool ok; 
    QString saxi;
    if (index.column() == 0) {
        return true;
    } else if (index.column() == 2) {
        saxi = QString("update DNSEntry set type = '%1' where id = %2").arg(value.toString().toUpper()).arg(id);
    } else if (index.column() == 3) {
        const QString salias = UriConvert(value.toString().toLower());
        if (tips !="NS") {
        saxi = QString("update DNSEntry set alias = '%1' where id = %2").arg(salias).arg(id);
        } else {
        saxi = QString("update DNSEntry set alias = '' where id = %1").arg(id);  
        }
    } else if (index.column() == 4) {
        
        int incommnig = value.toInt();
        if (incommnig < 300) {
         incommnig = 38000;
        }
        
        saxi = QString("update DNSEntry set ttl = '%1' where id = %2").arg(incommnig).arg(id);
        
        
    } else if (index.column() == 5) {
        QString ipnames = value.toString();
        ipnames = ipnames.replace(" ","");
        if (tips =="A") {
             if (!ValidIP(ipnames)) {
               ipnames = "127.0.0.1";  
             }
        } else {
             ipnames = HostNames(ipnames);
        }
        if (tips !="TXT") {
        saxi = QString("update DNSEntry set value = '%1' where id = %2").arg(ipnames).arg(id);
        } else {
        saxi = QString("update DNSEntry set value = '%1' where id = %2").arg(value.toString()).arg(id);   
        }
    } else if (index.column() == 6) {
        
        int prios = value.toInt();
        if (prios > 5 && tips == "MX") {
        saxi = QString("update DNSEntry set prior = '%1' where id = %2").arg(prios).arg(id);  
        } else {
        saxi = QString("update DNSEntry set prior = '' where id = %1").arg(id);  
        }
        
    } else if (index.column() == 7) {
        saxi = QString("update DNSEntry set comment = '%1' where id = %2").arg(value.toString()).arg(id);
    }
    QSqlQuery query(saxi,db);
    ok = query.exec();
    refresh();
    emit UpdatePlay();
    return ok;
}

void DNS_model::refresh()
{
    ////////////Coclose();
    
    const QString hostqueryx = QString("SELECT id,name,type,alias,ttl,value,prior,comment FROM DNSEntry WHERE name ='%1'")
    .arg(host);
    QSqlQuery query2sur(hostqueryx,db);
    setQuery(query2sur);
    setHeaderData(0, Qt::Horizontal, QObject::tr("ID"));
    setHeaderData(1, Qt::Horizontal, QObject::tr("DOMAINE"));
    setHeaderData(2, Qt::Horizontal, QObject::tr("TYPE"));
    setHeaderData(3, Qt::Horizontal, QObject::tr("ALIAS"));
    setHeaderData(4, Qt::Horizontal, QObject::tr("TTL"));
    setHeaderData(5, Qt::Horizontal, QObject::tr("VALUE"));
    setHeaderData(6, Qt::Horizontal, QObject::tr("MX_PRIORITY"));
    setHeaderData(7, Qt::Horizontal, QObject::tr("COMMENT"));
}

/* quote and dequote sql s result */
QString DNS_model::sql_Quote( QString xml )
{
   //the following checks are necessary before exporting
  //strings to XML. see http://hdf.ncsa.uiuc.edu/HDF5/XML/xml_escape_chars.html for details
   QString text = xml;
   text.replace("\"","\\\"");  /* 228 ``*/
   text.replace("'","\\\'");
   return text;
}



TabDelegate::TabDelegate( QTableView *ta , QObject *parent  )
    : QSqlRelationalDelegate(parent)
{
    tas = ta;
    
     dnstype << "A" << "CNAME" << "NS" << "MX" << "TXT"; 
}

void TabDelegate::SetLists( QStringList ips , QStringList hos , QString h )
{
    ramips = ips;
    ramhosts = hos;
    host = h;
}



void TabDelegate::paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
    if (index.column() == 0) {
        tas->setColumnWidth (0,160);
        tas->openPersistentEditor(index);
        return;
    } else if (index.column() == 1) {
        QString coder = index.model()->data(index, Qt::DisplayRole).toString();
        QStyleOptionViewItem myOption = option;
        myOption.displayAlignment = Qt::AlignLeft | Qt::AlignVCenter;
        myOption.palette.setColor( QPalette::Text , Qt::red );
        drawDisplay(painter, myOption, myOption.rect,coder);
        drawFocus(painter, myOption, myOption.rect); 
    } else if (index.column() == 2) {
        tas->setColumnWidth (2,72);
        tas->openPersistentEditor(index);
        return;
    }  else if (index.column() == 5) {
        tas->setColumnWidth (5,160);
        tas->openPersistentEditor(index);
        return;
    }  else{
        QItemDelegate::paint(painter, option, index);
    }
}



QWidget *TabDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
    if (index.column() == 0) {
        Base_Button *editora = new Base_Button(parent);
        connect( editora , SIGNAL(OpenItem(int)), this , SLOT(Omodusa(int)));
        connect( editora , SIGNAL(OpenItemb(int)), this , SLOT(Omodusb(int)));
        connect( editora , SIGNAL(OpenItemc(int)), this , SLOT(Omodusc(int)));
        return editora;
     } else  if (index.column() == 2 ) {
        QComboBox *editor = new QComboBox(parent);
        return editor;
    } else  if (index.column() == 5 ) {
        QComboBox *editor0 = new QComboBox(parent);
        editor0->setEditable(true);
        return editor0;
    } else {
        return QItemDelegate::createEditor(parent, option, index);
    }
}

void TabDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
    bool kwait =  false;
    int iidex = 0;
    
      if (index.column() == 0) {
        int xnummer = index.model()->data(index, Qt::DisplayRole).toInt();
        Base_Button *editorax = qobject_cast<Base_Button *>(editor);
        editorax->SetHost(host);
        editorax->SetNummer(xnummer);
     } else if (index.column() == 2 ) {
        QString typedns = index.model()->data(index, Qt::DisplayRole).toString();
        QComboBox *editorrun = qobject_cast<QComboBox *>(editor);
         if (editorrun) {
             
             if (!dnstype.contains(typedns)) {
              editorrun->addItem(typedns);
             } else {
               kwait = true;  
             }
             editorrun->addItems(dnstype);
             
             if (kwait) {
                 for (int i = 0; i < dnstype.size(); ++i) {
                     if (typedns == dnstype.at(i)) {
                     iidex = i;
                     }
                 }
                 editorrun->setCurrentIndex(iidex);
             }
         }
        
    }  else  if (index.column() == 5 ) {
        QComboBox *editorrun0 = qobject_cast<QComboBox *>(editor);
        if (editorrun0) {
            QString value = index.model()->data(index, Qt::DisplayRole).toString();
            editorrun0->addItem(value);
            editorrun0->addItems(ramhosts);
            editorrun0->addItems(ramips);
        }
        
    } else {
        QItemDelegate::setEditorData(editor, index);
    }
}

void TabDelegate::setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const
{
     if (index.column() == 0) {
          Base_Button *editorax = qobject_cast<Base_Button *>(editor);
          model->setData(index,editorax->GetNummer());
     } else if (index.column() == 2 ) {
        QComboBox *editorrun = qobject_cast<QComboBox *>(editor);
        if (editorrun) {
            model->setData(index,editorrun->currentText());
        }
    } else  if (index.column() == 5 ) {
         QComboBox *editorrun0 = qobject_cast<QComboBox *>(editor);
         if (editorrun0) {
           model->setData(index,editorrun0->currentText());  
         }
        
    } else {
        QItemDelegate::setModelData(editor, model, index);
    }
}


void  TabDelegate::Omodusa( int er ) {
   emit XOpModusa(er);
}
void  TabDelegate::Omodusb( int er ) {
   emit XOpModusb(er);
}

void  TabDelegate::Omodusc( int er ) {
   emit XOpModusc(er);
}


DB_dual::DB_dual(  const QString sqlitebasefile )
{
    dbfile = sqlitebasefile;
    connecter = true;
	Load_Connector();
}
//
void DB_dual::Load_Connector()
{
    db = QSqlDatabase::addDatabase("QSQLITE");
    db.setDatabaseName(dbfile);
    if (!db.open()) {
        QMessageBox::critical(0, qApp->tr("Cannot open database"),
            qApp->tr("Unable to establish a database connection.\n"
                     "This application needs SQLite support. Please read "
                     "the Qt SQL driver documentation for information how "
                     "to build it.\n\n"
                     "Click Cancel to exit."), QMessageBox::Cancel);
        connecter = false;
        return;
    }
    QStringList tlist = db.tables();
    if (!tlist.contains("NameResolv") || !tlist.contains("SoaRegister") || !tlist.contains("DNSEntry") ) {
        QString t1 = "CREATE TABLE SoaRegister (id INTEGER PRIMARY KEY, name TEXT, ttl_time NUMERIC, mail TEXT, master TEXT,greptime NUMERIC, expirytime NUMERIC, refreshtime NUMERIC, serial NUMERIC,transfer NUMERIC, filename TEXT,note TEXT)";
        QString t2 = "CREATE TABLE DNSEntry (id INTEGER PRIMARY KEY,name TEXT, type TEXT, alias TEXT, ttl NUMERIC , value TEXT, prior NUMERIC , comment TEXT)";
        QString t3 = "CREATE TABLE NameResolv (name TEXT, hasip TEXT, has NUMERIC )";
        QSqlQuery query("",db);
          query.exec(t1);
          query.exec(t2);
          query.exec(t3);
    }
    
    
    if (HostList().size() > 0) {
      FillResolveTableName(); 
    }
    
}






QStringList DB_dual::ReadDirBind( const QString dir )
{
    HostRecFile.clear();
    IndexDir(dir);
    return HostRecFile;
}

bool DB_dual::CheckHost( const QString host )
{
    bool notexist = false;
    QString checks = QString("SELECT id FROM SoaRegister WHERE name ='%1'").arg(host);
         QSqlQuery query(db);
         bool ok = query.exec(checks);
         Q_ASSERT(ok);
         int cora = 0;
                          while (query.next()) { 
                              QString sei = query.value(0).toString();
                              cora++;
                          } 
        if (cora > 0) {
        notexist = true; 
        } 
    return  notexist;       
}



void DB_dual::Paint_Table( const QString host , QTableView * tabi ) 
{
    
    QStringList ips = UniqueList("select value from DNSEntry where type ='A'");
    QStringList hosts = UniqueList("select value from DNSEntry where type ='MX' or type ='CNAME' or type ='NS'");
    TabDelegate *dele = new TabDelegate(tabi);
    dele->SetLists(ips,hosts,host);
    model = new DNS_model(db,host);
    connect(model, SIGNAL(UpdatePlay()), this , SLOT(DBUpdatePlay()));
    connect(model, SIGNAL(NewRow()), this , SLOT(NewRowPlay()));
    connect(dele, SIGNAL(XOpModusb(int)), this , SLOT(DBUpdatePlay()));
    connect(dele, SIGNAL(XOpModusa(int)), this , SLOT(NewRowPlay()));
    connect(dele, SIGNAL(XOpModusc(int)), this , SLOT(RemoveEDnsLine(int)));
    tabi->setModel(model);
    tabi->setItemDelegate(dele);
    tabi->setAlternatingRowColors(true);
    tabi->setColumnWidth (3,40);
    tabi->setColumnWidth (4,40);
    tabi->setColumnWidth (6,40);
    //////////connect(tabi->verticalHeader(),SIGNAL(sectionClicked(int)),model,SLOT(VertikalRow(int)));
}

void DB_dual::DBUpdatePlay() 
{
    emit ReloadItemCurrent();
}

void DB_dual::NewRowPlay() 
{
    emit NewItem();
}



void DB_dual::RemoveEDnsLine( int row ) 
{
         QString updateop = QString("DELETE FROM DNSEntry WHERE id = '%1'").arg(row);
         QSqlQuery query(db);
         bool fatt = query.exec(updateop);
         if (fatt) {
           emit ReloadItemCurrent();  
         } else {
             QMessageBox::critical(0, qApp->tr("Database error!"),
             qApp->tr("Unable to delete row entry %1.").arg(row), QMessageBox::Cancel);
         }
}



QString DB_dual::BindFormat( int id_table )
{
   const QString selecthost = QString("SELECT name,ttl_time,expirytime,refreshtime,serial,mail,master,transfer FROM SoaRegister WHERE id ='%1' ").arg(id_table);
    struct DNSjumper p;
         QSqlQuery query(db);
         bool ok = query.exec(selecthost);
         Q_ASSERT(ok);
    
        QStringList aliasentry;
                    aliasentry.clear();
          
        QDateTime fromunix = QDateTime::currentDateTime();
        
        QString update = fromunix.toString("yyyyMMddhh");
    
    QString bin,extension,nameclear;
                          while (query.next()) {
                              p.FullDomainName = query.value(0).toString();
                              p.Default_ttl = query.value(1).toInt();
                              p.Expirytime = query.value(2).toInt();
                              p.Refreshtime = query.value(3).toInt();
                              p.Mailtech = query.value(5).toString();
                              p.Serialnr = query.value(4).toInt();
                              p.Masterdns = query.value(6).toString();
                              p.Transferretrytime = query.value(7).toInt();
                          }
            const QString masterip = IPsCacheFrom(p.Masterdns);
                          
            if (p.FullDomainName !="") {
                            
                
             QString hostio = p.FullDomainName;
             QStringList pare = hostio.split(".");
                if (pare.size() == 2) {
                  extension = pare.at(1);  
                  nameclear = pare.at(0); 
                }
                
                
                
            p.Mailtech = QString(p.Mailtech).replace("@",".");
            bin += QString("; UPDATE AT %1 BY %2 \n").arg(update).arg(_PROGRAM_TITLE_ );
            bin += QString("; Master %2 resolv to %1 \n\n").arg(masterip).arg(p.Masterdns);
            bin += QString("$ttl %1\n").arg(p.Default_ttl);
            bin += QString("$ORIGIN %1.\n").arg(extension.trimmed());
            bin += QString("%1\t%2\tIN\tSOA  %3.  %4. (\n").arg(nameclear.trimmed()).arg(p.Default_ttl).arg(p.Masterdns).arg(p.Mailtech);
            bin += QString("\t%1\n\t%2\n\t%3\n\t%4\n\t%5 )\n").arg(p.Serialnr).arg(p.Refreshtime).arg(p.Transferretrytime).arg(p.Expirytime).arg(p.Default_ttl);
            }
bin += QString("\n");   
bin += QString("; TIMESTAMP SERIAL Type--- %1 ---\n").arg(update);         
bin += QString("$ORIGIN %1.\n").arg(p.FullDomainName); 
bin += QString("\n");          
            
if (p.FullDomainName !="") {          
const QString seldns = QString("select value from DNSEntry where name = '%1' and type ='NS'").arg(p.FullDomainName);
bool ok1 = query.exec(seldns);
Q_ASSERT(ok1);
    while (query.next()) {
        bin += QString("\tIN\tNS\t%1.\n").arg(query.value(0).toString());
    }
}

if (p.FullDomainName !="") {          
const QString GetASettingDomaine = QString("select value,alias from DNSEntry where name = '%1' and type ='A'").arg(p.FullDomainName);
bool ok1 = query.exec(GetASettingDomaine);
Q_ASSERT(ok1);
    while (query.next()) {
        
        QString aliasesss = query.value(1).toString();
        if (aliasesss.size() == 0 ) {
        bin += QString("\tIN\tA\t%1\n").arg(query.value(0).toString());
        } else {
        aliasentry.append(QString("%2\tIN\tA\t%1\n").arg(query.value(0).toString()).arg(aliasesss));  
        }
    }
}


if (p.FullDomainName !="") {          
const QString GetMailSetting = QString("select value,prior,alias from DNSEntry where name = '%1' and type ='MX'").arg(p.FullDomainName);
bool ok1 = query.exec(GetMailSetting);
Q_ASSERT(ok1);
    while (query.next()) {
        QString aliasses = query.value(2).toString();
        if (aliasses.size() < 1) {
        bin += QString("\tIN\tMX\t%2 %1.\n").arg(query.value(0).toString()).arg(query.value(1).toString());
        } else {
        aliasentry.append(QString("%3\tIN\tMX\t%2 %1.\n").arg(query.value(0).toString()).arg(query.value(1).toString().arg(aliasses))); 
        }
    }
}

bin += QString("\n"); 
//////////bin += QString("\n"); 
if (aliasentry.size() > 0) {
bin.append(aliasentry.join(""));
}

if (p.FullDomainName !="") {          
const QString selmx2 = QString("select alias,value from DNSEntry where name = '%1' and type ='CNAME' and alias !=''  ").arg(p.FullDomainName);
bool ok1 = query.exec(selmx2);
Q_ASSERT(ok1);
    while (query.next()) {
        
        /* check if cname contains ip */
        QString cnmamedest = query.value(1).toString();
        if (ValidIP(cnmamedest)) {
            cnmamedest = p.FullDomainName;
        }
        bin += QString("%1\tIN\tCNAME\t%2.\n").arg(query.value(0).toString()).arg(cnmamedest);
    }
}


if (p.FullDomainName !="") {          
const QString selmx2 = QString("select alias,value from DNSEntry where name = '%1' and type ='TXT' ").arg(p.FullDomainName);
bool ok1 = query.exec(selmx2);
Q_ASSERT(ok1);
    while (query.next()) {
        bin += QString("%1\tIN\tTXT\t\"%2\"\n").arg(query.value(0).toString()).arg(query.value(1).toString());
    }
}
bin += QString("\n"); 
bin += QString("\n"); 
bin += QString("\n"); 
bin += QString("\n"); 
bin += QString("; Sample Sender Policy MX Mail smtp server. \n");  
bin += QString("; allow sender ip from smtp ip xx and reverse ip to name / if not spam!\n");
bin += QString(";\t300	IN	TXT	\"v=spf1 ip4:64.4.33.7 ip4:64.4.33.8 ip4:64.4.33.8 mx ptr ?all\"\n").arg(p.FullDomainName);          
bin += QString("; Sender Policy Framework http://www.openspf.org/Project_Overview\n"); 

    return bin;
                          
}
/*
2007051602 serie
			10800 refre
			3600  transfer
			604800 expire
			38400 ) ttl

*/


bool DB_dual::UpdateUnion( const QString field , uint value )
{
    QString updaterr = QString("UPDATE SoaRegister SET %1 = '%2' WHERE id > 0").arg(field).arg(value);
         QSqlQuery query(db);
    
    if (field == "ttl_time" ) {
        QString updaaliasentry = QString("UPDATE DNSEntry SET ttl ='%1' WHERE id > 0").arg(value);
        query.exec(updaaliasentry);
    }
    
    
    
    /////////////std::cout << "UpdateUnion  " << qPrintable(updaterr) << std::endl; 
    
   return query.exec(updaterr);
    
}


bool DB_dual::RemoveHost( const QString host , int idbs )
{
    QString updaterr = QString("DELETE FROM SoaRegister WHERE id = %1").arg(idbs);
    
    QString updateop = QString("DELETE FROM DNSEntry WHERE name = '%1'").arg(host);
    
         QSqlQuery query(db);
    
    query.exec(updateop);
    
    
   std::cout << "host remove  " << qPrintable(host) << std::endl; 
    
   return query.exec(updaterr);
    
}





QStringList DB_dual::HostList()
{
    QStringList hosts;
    QString selects = QString("SELECT name FROM SoaRegister ORDER BY name");
         QSqlQuery query(db);
         bool ok = query.exec(selects);
         Q_ASSERT(ok);
         hosts.clear();
                          while (query.next()) { 
                              QString sei = query.value(0).toString();
                              hosts.append(sei);
                          } 
       return  hosts;       
}

QStringList DB_dual::DNSMasterList()
{
    QStringList hosts;
    QString selects = QString("SELECT master FROM SoaRegister ORDER BY master");
         QSqlQuery query(db);
         bool ok = query.exec(selects);
         Q_ASSERT(ok);
         hosts.clear();
                          while (query.next()) { 
                              QString sei = query.value(0).toString();
                              hosts.append(sei);
                          } 
       return  hosts;       
}


QStringList DB_dual::UniqueList( const QString queryunique )
{
    QStringList masterlist;
         QSqlQuery query(db);
         bool ok = query.exec(queryunique);
         Q_ASSERT(ok);
         masterlist.clear();
                          while (query.next()) { 
                              QString sei = query.value(0).toString();
                              if (!masterlist.contains(sei,Qt::CaseSensitive)) {
                              masterlist.append(sei);
                              }
                          } 
    return masterlist;       
}






void DB_dual::FillResolveTableName()
{
    QStringList hostlistnow = HostList();
    QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
    
    BaseQuery("delete from NameResolv where has =0");
    BaseQuery("delete from NameResolv where has =1");
    
    QStringList unique;
                unique.clear();
    
    
    for (int i = 0; i < hostlistnow.size(); ++i)  {
        const QString gh = hostlistnow.at(i);
        
        if (!unique.contains(gh)) {
             unique.append(gh);
             std::cout << "startresolve  " << qPrintable(gh) << std::endl; 
             QHostInfo::lookupHost(gh, this, SLOT(lookedUpName(QHostInfo)));
        }
    }
    QStringList hostlistnow1 = DNSMasterList();
    
     for (int i = 0; i < hostlistnow1.size(); ++i)  {
        const QString gh1 = hostlistnow1.at(i);
        
         if (!unique.contains(gh1)) {
             unique.append(gh1);
             std::cout << "startresolve  " << qPrintable(gh1) << std::endl; 
             QHostInfo::lookupHost(gh1, this, SLOT(lookedUpName(QHostInfo)));
         }
    }
    
     unique.clear();
    
     QTimer::singleShot(2000, this, SLOT(ResetCursorW()));
    
}

void DB_dual::ResetCursorW()
{
QApplication::restoreOverrideCursor();
}

void DB_dual::lookedUpName(const QHostInfo &host)
{
    QStringList roundlist;
    QString sql;
    
        if (host.error() != QHostInfo::NoError) {
        sql = QString("REPLACE INTO NameResolv VALUES('%1','0.0.0.0',0);").arg(host.hostName());
        BaseQuery(sql);  
                    
        return;
        }
        foreach (QHostAddress address, host.addresses()) {
        roundlist.append(address.toString());
        }
    
        if (roundlist.size() > 0) {
            
           std::cout << "end  " << qPrintable(roundlist.at(0)) << std::endl; 
            
        sql = QString("REPLACE INTO NameResolv VALUES('%1','%2',1);").arg(host.hostName()).arg(roundlist.at(0));
        BaseQuery(sql);
        } else {
        return;
        }
        
        
}


QString DB_dual::IPsCacheFrom( const QString HostName )
{
    const QString resolverr = QString("SELECT hasip,has FROM NameResolv WHERE name ='%1' ").arg(HostName);
    QSqlQuery query(CurrentDB());
    bool ok = query.exec(resolverr);
    Q_ASSERT(ok);
    int tieni;
    QString ipd = "0.0.0.0";
    
                        while (query.next()) {
                            tieni = query.value(1).toInt();
                            ipd = query.value(0).toString();
                            if (tieni == 1) {
                            /* take first fast */
                            return ipd;
                            }
                        }
    return ipd;
}



int DB_dual::direct_int(QString xid)
{
    xid = xid.replace(QString(" "), QString("")); /* trimm */
    int newnummer = 0;
    
    bool ok; 
    xid.toFloat(&ok);
    
    if (ok) {
    newnummer = xid.toInt(&ok);
    return newnummer;
    }
 return newnummer;
}





bool DB_dual::BaseQuery( const QString sqls )
{
         QSqlQuery query(db);
         return query.exec(sqls);
}



void DB_dual::IndexDir(const QString d)
{
   QDir dir(d);
   if (dir.exists())
   {
      const QFileInfoList list = dir.entryInfoList();
      QFileInfo fi;
      for (int l = 0; l < list.size(); l++)
      {
         fi = list.at(l);
         if (fi.isDir() && fi.fileName() != "." && fi.fileName() != "..") {
            IndexDir(fi.absoluteFilePath());
         } else if (fi.isFile() ) {
                /* || fi.suffix().contains("rev", Qt::CaseInsensitive) */
             if ( fi.suffix().contains("host", Qt::CaseInsensitive) ) {
                  HostRecFile.append(fi.absoluteFilePath());
             }
         } 
        
      }
   }
}

QString DB_dual::ExportTbs()
{
    QDateTime fromunix = QDateTime::currentDateTime();
    QString update = fromunix.toString("yyyyMMddhh");
    QString exporttxt = QString("# Export UPDATE AT %1 BY %2 \n").arg(update).arg(_PROGRAM_TITLE_ );

    QSqlQuery query(CurrentDB());
    bool ok = query.exec("SELECT sql  FROM sqlite_master");
    Q_ASSERT(ok);
    
                        while (query.next()) {
                            exporttxt.append(QString("# %1\n").arg(query.value(0).toString()));
                        }
    
    
    
    
    QStringList tlist = db.tables(); 
    for (int i = 0; i < tlist.size(); ++i) {
        exporttxt.append("\n");
        exporttxt.append(TableExport(tlist.at(i)));
        exporttxt.append("\n");
    }
    return exporttxt;
}


bool DB_dual::ValidIP( QString ipadress )
{
      QStringList slist = ipadress.split(".");
      int s = slist.size();
      if (s >4) {
      return false;
      }
      for(int i=0;i<s;i++){
        bool ok;
        int val = slist[i].toInt(&ok);
        if(!ok || val<0 || val>255) return false;
      }
      return true;
}



QString DB_dual::TableExport( const QString table  )
{
    const QString cattable = QString("SELECT * FROM %1").arg(table);
    QSqlQuery query(CurrentDB());
    bool ok = query.exec(cattable);
    Q_ASSERT(ok);
    QSqlRecord rec = query.record();
    int sumcol = rec.count();
    QStringList cvslines;
    QStringList Fname;
    QStringList Fvalue;
    cvslines.clear();
    
    
                    while (query.next()) {
                    Fvalue.clear();
                        
                             for(int i=0;i<sumcol;i++){
                             QString value = query.value(i).toString();
                                 if (value.isEmpty()) {
                                 Fvalue.append("NULL");
                                 } else {
                                 Fvalue.append(QString("'%1'").arg(value));  
                                 }
                             }
                             
                    QString Dvalue = Fvalue.join(",");
                    cvslines.append(QString("REPLACE INTO %1 VALUES (%2);").arg(table).arg(Dvalue));
                    }
                    
    QString contentxt = cvslines.join("\n");
    return contentxt;
}




/* Q_ASSERT ( bool test )  */ 

/* QString one;  toLower() toUpper()  split(",")  endsWith() startsWith()  QByteArray QString::toAscii() */
/* int nummer; */ 
/* QStringList list;  join();  */ 
/* QUrl url; */ 
/* QByteArray byteArray; */ 
/* bool having; */ 
/* QDomDocument doc;*/ 
/* QDomElement root;*/ 
