#ifndef DB_DUAL_H
#define DB_DUAL_H
#include <iostream>
#include <stdio.h>
#include <unistd.h>
#include <iostream>
#include <QtCore>
#include <QDebug>
#include <QCoreApplication>
#include <QObject>
#include <QSqlError>
#include <QSqlQuery>
#include <QSqlTableModel>
#include <QSqlRelationalTableModel>
#include <QSqlRelationalDelegate>
#include <QHeaderView>
#include <QSqlRecord>
#include <QSqlDatabase>
#include <QtGui>
#include <QtCore>
#include "main.h"



/*
CREATE TABLE DNSEntry (
id INTEGER PRIMARY KEY,
name TEXT, 
type TEXT, 
alias TEXT, 
ttl NUMERIC , 
value TEXT, 
prior NUMERIC , 
comment TEXT);

*/


class Base_Button: public QWidget
{
    Q_OBJECT
//
public: 
    QPushButton *pushButton;

Base_Button( QWidget *parent )
: QWidget(parent)
{
    setAttribute(Qt::WA_WindowPropagation);
    QVBoxLayout *widgetLayout = new QVBoxLayout(this);
    widgetLayout->setMargin(0);
    widgetLayout->setSpacing(0);
    pushButton = new QPushButton(this);
    pushButton->setText(tr("DNS"));
    pushButton->setCursor(QCursor(static_cast<Qt::CursorShape>(13)));
    ////pushButton->setFlat(true);
    widgetLayout->addWidget(pushButton);
    
}
void SetNummer( int numero ) {
   identificativo = numero;
   pushButton->setText(tr("Entry Nr.%1").arg(identificativo)); 

   opeitema = new QAction(this);
   opeitema->setText(tr("Append entry")); 
   connect(opeitema, SIGNAL(activated()), this,  SLOT(OpenFirst()));
    opeitemb = new QAction(this);
   opeitemb->setText(tr("Reload table")); 
   connect(opeitemb, SIGNAL(activated()), this,  SLOT(OpenFirstb()));
    opeitemc = new QAction(this);
   opeitemc->setText(tr("Remove entry Nr.%1").arg(identificativo)); 
   connect(opeitemc, SIGNAL(activated()), this,  SLOT(OpenFirstc()));
   opeitemd = new QAction(this);
   opeitemd->setText(tr("Copy %1 to clipboard.").arg(host)); 
   connect(opeitemd, SIGNAL(activated()), this,  SLOT(OpenFirstd()));
   /////////opeiteme = new QAction(this);
   //////////opeiteme->setText(tr("Open REG Web.")); 
   ///////connect(opeiteme, SIGNAL(activated()), this,  SLOT(OpenFirste()));

    QMenu *menu = new QMenu(this);
    menu->addAction(opeitema);
    menu->addAction(opeitemb);
    menu->addAction(opeitemd);
    menu->addAction(opeitemc);
      //////// menu->addAction(opeitemd);
        ///////menu->addAction(opeiteme);;
    pushButton->setMenu(menu);
    
    
    
}

int GetNummer() {
   return identificativo;
}
void SetHost( const QString h ) {
   host = h;
}
private:
    QAction *opeitema;
    QAction *opeitemb;
    QAction *opeitemc;
    QAction *opeitemd;
    QAction *opeiteme;
    int identificativo;
    QSize sizebase;
    QString host;
protected:
signals:
   void OpenItem( int ei );
   void OpenItemb( int ei );
   void OpenItemc( int ei );
   void OpenItemd( int ei );
   void OpenIteme( int ei );
public slots:
void  OpenFirst() {
  emit OpenItem(identificativo);
}
void  OpenFirstb() {
  emit OpenItemb(identificativo);
}
void  OpenFirstc() {
  emit OpenItemc(identificativo);
}
void  OpenFirstd() {
    QClipboard  *baseram = QApplication::clipboard();
    baseram->clear();
    baseram->setText(host,QClipboard::Clipboard);
}
void  OpenFirste() {
  emit OpenIteme(identificativo);
}

};






class DNS_model : public QSqlTableModel
{
     Q_OBJECT
public:
    DNS_model(const QSqlDatabase dbin , const QString domaine );
    Qt::ItemFlags flags(const QModelIndex &index) const;
    bool setData(const QModelIndex &index, const QVariant &value, int role);
    bool ValidIP( QString ipadress );
signals:
    void UpdatePlay();
    void NewRow();
private:
    QString host;
    int waitremoval;
    QString sql_Quote( QString xml );
    QSqlDatabase db;
    
    QMenu *TContext;
public slots:
void VertikalRow( int line );
void AppenEntry();
void ReMoveLine();
void Coclose();
void refresh();

};


class TabDelegate : public QSqlRelationalDelegate
{
    Q_OBJECT

public:
    TabDelegate( QTableView *ta , QObject *parent = 0 );
    void SetLists(QStringList ips , QStringList hos , QString h);
    void paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const;
    QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option, const QModelIndex &index) const;
    void setEditorData(QWidget *editor, const QModelIndex &index) const;
    void setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const;
signals:
    void  XOpModusa(int a);
    void  XOpModusb(int a);
    void  XOpModusc(int a);
public slots:
    void  Omodusa( int er );
    void  Omodusb( int er );
    void  Omodusc( int er );
private:
    QTableView *tas;
    QStringList dnstype;
    QStringList ramips;
    QStringList ramhosts;
    QString host;
};




class DB_dual : public QObject
{
     Q_OBJECT
//
public:
   DB_dual( const QString sqlitebasefile );
   QStringList ReadDirBind( const QString dir );
   QString TableExport( const QString table  );
   QString ExportTbs();
   bool ValidIP( QString ipadress );
   bool CheckHost( const QString host );
   bool BaseQuery( const QString sqls );
   bool UpdateUnion( const QString field , uint value );
   QStringList HostList();
   QStringList DNSMasterList();
   QString IPsCacheFrom( const QString HostName );
   void Paint_Table( const QString host , QTableView * tabi );
   int direct_int(QString xid);
   QString BindFormat( int id_table );
   bool RemoveHost( const QString host , int idbs );
   void FillResolveTableName();
   QStringList UniqueList( const QString queryunique );
   inline bool Connect() { return connecter; }
   inline QSqlDatabase CurrentDB() { return db; }
protected:
    void IndexDir(const QString d);
    DNS_model *model;
QHeaderView *vertikalheader;
QString dbfile;
QSqlDatabase db;
QString one;
int nummer;
QStringList HostRecFile;
QUrl url;
QByteArray byteArray;
bool connecter;
/////QDomDocument doc;
//////QDomElement root;
private:
  void Load_Connector();
  signals:
  void ReloadItemCurrent();
  void NewItem();
public slots:
    void DBUpdatePlay();
    void NewRowPlay();
    void RemoveEDnsLine( int row );
    void lookedUpName(const QHostInfo &host);
    void ResetCursorW();

};
//
#endif // DB_DUAL_H

