#ifndef RESOLVE_H
#define RESOLVE_H
#include <iostream>
#include <stdio.h>
#include <unistd.h>
#include <iostream>
#include <QtCore>
#include <QObject>


typedef struct DNSsample {
  uint Serialnr;           /* serial to change to uint time null */ 
  uint Default_ttl;               /* time to live  */
  uint Refreshtime;               /* time to live  */
  uint Expirytime;               /* time to live  */
  uint Transferretrytime;        /* time to live  */
  uint Records_ttl;              /* time to live  */
  QDateTime ReadDateTime;
  QString DomainExtension;  
  QString DomainName; 
  QString FullDomainName;    
  QString Mailtech;             /* mail admin   */
  QString Masterdns;        /* master on soa  */
  QString Origifilename;      /* grep from file   */
  QString OriginalSoaLine;        /* master on soa  */
  QString SoaCat;        /* only soa (nummers 33 33 33 33 33)  */
  QString Separator;             /* separator line coolumn   */
  QString HtmlReport;     /* html report status */
  QString QfileInfo;     /* filename - path */
  QStringList LineInfo;     /* InfoLine dns and Record */
};


#include "main.h"

class Base_Master
{
    
public:
 Base_Master() { }
QString CleanName( QString name ) {
    
    if (name.endsWith (".")) {
        name = name.left(name.size() - 1);
        return name;
    } else {
        return name;
    }
}
QStringList BindLines( QString linex ) {
    QStringList vari = linex.split("\t",QString::SkipEmptyParts);
    QString pending = vari.join("|");
    QStringList last = pending.split(" ",QString::SkipEmptyParts);
    QString pending1 = last.join("|");
    return pending1.split("|",QString::SkipEmptyParts);
}

QString DesktopFile( QString fullFileName )
{
    if (fullFileName.startsWith("http://", Qt::CaseInsensitive) or 
        fullFileName.startsWith("https://", Qt::CaseInsensitive) or
        fullFileName.startsWith("ftp://", Qt::CaseInsensitive) or
        fullFileName.startsWith("news://", Qt::CaseInsensitive) or
        fullFileName.startsWith("mailto:", Qt::CaseInsensitive) or
        fullFileName.startsWith("webdav://", Qt::CaseInsensitive)  )
       { 
         return fullFileName;
       } else {
         return fullFileName.prepend("file:///");  
       }
}
QString BindToQuery( QString linex ,  QString host ) {
    QString tipe ="";
    QString value ="";
    QString ttl ="";
    QString mxprior ="";
    QString aliase = "";
    QString name = CleanName(host);
    QString grep = BindLines(linex).join("|");
    QStringList param = grep.split("|",QString::SkipEmptyParts);
    
    if (param.size() < 3) {
    return tipe;
    }
    
    
    if (grep.contains("|NS|")) {
        tipe = "NS";
        value = CleanName(param.last());
    } else if (grep.contains("|MX|")) {
        tipe = "MX";
        /* prior */
        if (GoDigits(param.at(param.size() - 2))) {
           mxprior = CleanName(param.at(param.size() - 2));
        }
        value = CleanName(param.last());
    } else if (grep.contains("|CNAME|")) {
        tipe = "CNAME";
        value = CleanName(param.last());
    } else if (grep.contains("|A|")) {
        tipe = "A";
        value = CleanName(param.last());
    } else if (grep.contains("|TXT|")) {
        tipe = "TXT";
        value ="\"Unknow text\"";
    }
    
     QString firster = param.first();
    
     if (GoDigits(firster)) {
       ttl = QString("%1").arg(direct_int(firster));
     } else {
         if (firster !="IN") {
             firster = CleanName(firster.replace(name,""));
             if (tipe == "A" || tipe == "CNAME" || tipe == "MX" || tipe == "TXT" ) {
                 aliase = firster.replace(".","");
                 ////firster = firster.append(".");
                 //////aliase = firster.append(name);
             }
         }
         
     }
     
     
     /* id, name , type , alias , ttl , value , prior , comment */
     /* QString t2 = "CREATE TABLE DNSEntry (id INTEGER PRIMARY KEY,name TEXT, type TEXT, alias TEXT, ttl NUMERIC , value TEXT, prior NUMERIC , comment TEXT)"; */
    QString query = QString("INSERT INTO DNSEntry VALUES(NULL,'%1','%2','%3','%4','%5','%6','');")
     .arg(name)
     .arg(tipe)
     .arg(aliase)
     .arg(ttl)
     .arg(value)
     .arg(mxprior);
    return query;
}


QString GrepHostName( QString namedome ) {
    namedome = CleanName(namedome);
    QUrl url("http://"+namedome.trimmed()+"/");
    if (!url.isValid()) {
     return QString();
    } else {
     return url.host();
    }
}

QString GrepExtensionName( QString namedome ) {
    
    QString name = GrepHostName(namedome);
    if (name.size() < 1) {
     return QString();  
    } else { 
        name = name.mid(name.indexOf("."));
        name = name.replace(".","");
        return name;
    }
}

QString GrepCNameName( QString namedome ) {
    
    QString name = GrepHostName(namedome);
    QString ext = GrepExtensionName(namedome);
    if (name.size() < 1 && ext.size() < 1) {
     return QString();  
    } else {
        name = name.replace(ext,"");
        return CleanName(name);
    }
}






int direct_int(QString xid)
{
    xid = xid.replace(QString(" "), QString("")); /* trimm */
    int newnummer = 0;
    
    bool ok; 
    xid.toFloat(&ok);
    
    if (ok) {
    newnummer = xid.toInt(&ok);
    return newnummer;
    }
 return newnummer;
}

/* the line go only nummers exept ( ) */
bool GoDigits( QString xid )
{
    xid = xid.replace(QString(")"), QString("")); /* trimm */
    xid = xid.replace(QString(" "), QString("")); /* trimm */
    int newnummer = 0;
    bool ok = false; 
    xid.toFloat(&ok);
    return ok;
}

bool file_contents_append(QString fullFileName,QString xml)
{
    
    if (fullFileName.contains("/", Qt::CaseInsensitive)) {
    QString ultimacartellaaperta = fullFileName.left(fullFileName.lastIndexOf("/"))+"/";
    QDir dira(ultimacartellaaperta);
    if ( dira.mkpath(ultimacartellaaperta) ) { } else {
    return false;
    }
    }
    
    
    QString data = xml+"\n";
    QFile f( fullFileName );
	if ( f.open( QFile::Append | QFile::Text ) )
	{
		QTextStream sw( &f );
		sw << data;
		f.close();
		return true;
	}
	return false;
    
}

/* write a file to iso format */
bool fwriteiso(QString fullFileName,QString xml)
{
    
    if (fullFileName.contains("/", Qt::CaseInsensitive)) {
    
    QString ultimacartellaaperta = fullFileName.left(fullFileName.lastIndexOf("/"))+"/";
    QDir dira(ultimacartellaaperta);
    if ( dira.mkpath(ultimacartellaaperta) ) { } else {
    return false;
    }
    
    }
    
    
        QTextCodec *codecx;
        codecx = QTextCodec::codecForMib(4);
        QFile f( fullFileName );
        if ( f.open( QFile::WriteOnly | QFile::Text ) )
        {
        QTextStream sw( &f );
        sw.setCodec(codecx);
        sw << xml;
        f.close();
        return true;
        }
        return false;
}



};



/*

BEGIN TRANSACTION;
CREATE TABLE SoaRegister (
id INTEGER PRIMARY KEY, 1
name TEXT,  2
ttl_time NUMERIC,  3
mail TEXT,  4
master TEXT,  5
greptime NUMERIC,  8
expirytime NUMERIC,  9
refreshtime NUMERIC,  10
serial NUMERIC, 11
filename TEXT, 12
note TEXT); 13
COMMIT;

*/

/* container of dns settinf */

class DNS_Item : public QObject, public Base_Master
{
    Q_OBJECT
public:
 DNS_Item( const DNSjumper &info )
{
  x = info;
    
    QDateTime fromunix = x.ReadDateTime;
    uint timegrep = fromunix.toTime_t();
    
    sqlcreate.clear();
    
  HostNameFull = x.FullDomainName;
  QString initsoa = QString("INSERT INTO SoaRegister VALUES(NULL,'%1',%2,'%3','%4',%5,%6,%7,%8,%9,'%10','Take from file');")
  .arg(HostNameFull)  /* 1 */
    .arg(x.Default_ttl) /* 2 */
    .arg(x.Mailtech) /* 3 */
    .arg(x.Masterdns) /* 4 */
    .arg(timegrep) /* 5 */
    .arg(x.Expirytime) /* 6 */
    .arg(x.Refreshtime) /* 7 */
    .arg(x.Serialnr) /* 8 */
    .arg(x.Transferretrytime) /* 9 */
    .arg(x.QfileInfo); /* 10 */
    
    sqlcreate.append(initsoa);
    /* append aliases mx cname ns ecc... from file lines */
    QStringList aliases = Get_RLine();
     for (int i = 0; i < aliases.size(); ++i) {
         QString vari = BindToQuery(aliases.at(i),HostNameFull);
         sqlcreate.append(vari);
     }
    
    
    
    
    
    
}
inline void  SetIps( QStringList ips ) { nametoip = ips; }
/////////inline QStringList Get_Line() { return x.LineInfo; }
inline QStringList Get_Ips() { return nametoip; }
inline QString Get_Mail() { return x.Mailtech; }
inline QString Get_Ofile() { return x.Origifilename; }
inline QString Get_SOA() { return x.OriginalSoaLine; }
inline QString Get_SOAPars() { return x.SoaCat; }
inline QString Get_Name() { return x.DomainName; }
inline QStringList Get_RLine() { return x.LineInfo; }
inline QStringList Get_Sqlinsert() { return sqlcreate; }
inline QString Get_Report() { return x.HtmlReport; }
inline QString Get_FullDomain() { return HostNameFull; }
inline QString Get_Extension() { return x.DomainExtension; }
inline uint Get_Default_ttl() { return x.Default_ttl; }
inline uint Get_Serialnr() { return x.Serialnr; }
inline uint Get_Expirytime() { return x.Expirytime; }
inline uint Get_Transferretrytime() { return x.Transferretrytime; }
inline uint Get_Refreshtime() { return x.Refreshtime; }
protected:
    DNSjumper x;
    QString HostNameFull;
    QStringList nametoip;
    QStringList sqlcreate;
    QStringList foo;
private:

};


class ParseHostFi : public QThread, public Base_Master
{
    Q_OBJECT
public:
void SetFile( const QString filego ) 
{
  fi = filego;
}
void run() {
 if (fi.size() < 1) {
        emit ErrorMsg(QString("Mistake file found or null!"));
        exit(0);
        return;        
    }
    /*###########################################################################*/
                struct DNSjumper p;
                char *dote = ".";
                QChar point(dote[0]);
                QFileInfo info(fi);
                QFile file(fi); 
                QString SOALine;
                const QString GrepFromFile = info.fileName();
                p.QfileInfo = GrepFromFile;
                p.Separator = "|";
                QString DeafaultTTL;
                QString extension,tmp1,tmp2,dmail;
                p.DomainName = "#_error_error_#";
                p.Default_ttl = 60;  /* if not having set to 60 sec. */
                int nrline = 0;
                bool ok;
                bool catsoa = false;
                bool extdomain = false;
                bool havingDttl = false;
                if( !file.open( QIODevice::ReadOnly | QIODevice::Text ) ) {
                    emit ErrorMsg(QString("Unable to read file -> %1").arg(info.fileName()));
                    exit(0);
                }
                
                        QTextStream in( &file );
                        int currentLineNr = 0;
                        p.ReadDateTime = QDateTime::currentDateTime();
                        p.Origifilename = fi;
                        
    
    
                   while( ! in.atEnd() ) {
                   catsoa = false;
                   nrline++;
           
           
                    QString line( in.readLine() );   /* line string */
                
                   if (line.startsWith("$ttl")) {
                    /* having a default ttl */
                       DeafaultTTL = line;
                       DeafaultTTL = DeafaultTTL.replace("$ttl","");
                       DeafaultTTL = DeafaultTTL.replace("","");
                       p.Default_ttl = DeafaultTTL.toInt(&ok);
                       if (ok) {
                        havingDttl = true;
                       }  
                       SOALine ="";
                   } 
                   
                    /* check comment line or null or marks $ORIGIN ch.*/
                   if (line.startsWith("$ORIGIN") && line.endsWith(".") && line.count(".") == 1) {
                       extension = line;
                       extension = extension.replace("$ORIGIN","");
                       extension = extension.replace(" ","");
                       extension =  CleanName(extension);  /* remove last dot */
                       int sumdot = extension.count(point);
                       
                               if (sumdot == 0) {
                                 p.DomainExtension = extension;
                                 extdomain = true;
                               } 
                               if (sumdot == 1) {
                                 p.DomainExtension = GrepExtensionName(extension);
                                 p.FullDomainName = GrepHostName(extension);
                                 p.DomainName = GrepCNameName(extension);
                                 extdomain = true;
                               }
                   }
                   
                   if (line.startsWith("$") || line.startsWith(";") || line.size() < 1 ) {
                   continue;
                   }
                   
                   if (line.contains(";")) {
                   line = line.left(line.indexOf(";"));
                   }
                   
                   
                   
                  if (line.contains("SOA") && line.contains("IN") ) {
                    catsoa = true;
                  } 
                  if (GoDigits(line))  {
                    catsoa = true;
                  }
                  
                  
                    
                  if (catsoa) {
                     SOALine.append(line); 
                  } else {
                     AccLine.append(line);   
                  }

                  
           
           
       }
       /* end loop */
       
       int fpas = SOALine.indexOf("(");
       p.OriginalSoaLine = SOALine;
       const QString spare = SOALine.mid(fpas, SOALine.size() - fpas);
       QString mailinfo = SOALine.left(fpas);
       QRegExp rx("(\\d+)");
       QStringList NummersSerial;
       QStringList FullSoaLine;
       QStringList Mastermail;
       QStringList mastermake = mailinfo.split("\t");
       int pos = 0;
       
       
         while ((pos = rx.indexIn(spare, pos)) != -1) {
             NummersSerial << rx.cap(1);  /* only on bracket () */
             pos += rx.matchedLength();
         }
         pos = 0;
         
         while ((pos = rx.indexIn(SOALine, pos)) != -1) {
             FullSoaLine << rx.cap(1);  /* full line find default ttl on soa  */
             pos += rx.matchedLength();
         }
         
          if ( FullSoaLine.size() > 5 ) {
             if (!havingDttl) {
              p.Default_ttl = direct_int(FullSoaLine.at(0));
             }
          }
         
         
          QString soares = FullSoaLine.join("-");
          
         if (NummersSerial.size() > 4 ) {
             p.Serialnr = direct_int(NummersSerial.at(0));
             p.Expirytime = direct_int(NummersSerial.at(3));
             p.Transferretrytime = direct_int(NummersSerial.at(2));
             p.Refreshtime = direct_int(NummersSerial.at(1));
         } else {
                  emit ErrorMsg(QString("e451 Unable to grep this SOA! \"%2\" on file %1").arg(GrepFromFile).arg(soares));
                 return; 
                 exit(0);
            }
         
         
       
            
       /////////std::cout << "\n" << std::endl;
      ////////std::cout << "Default_ttl." << p.Default_ttl << std::endl;
       ///////////std::cout << "Serialnr." << p.Serialnr << std::endl;
       ////////std::cout << "Expirytime."<<  p.Expirytime << std::endl;
       ////////std::cout << "Transferretrytime." << p.Transferretrytime << std::endl;
       ///////////std::cout << "Refreshtime." << p.Refreshtime << std::endl;
       
         
       if (mastermake.size() > 0) {
        p.DomainName = CleanName(QString(mastermake.at(0)).replace(" ",""));
        tmp1 = CleanName(QString(mastermake.at(0)).replace(" ",""));
       }
       
       if (tmp1.size() > 4 && tmp1.contains(".")) {
           p.DomainExtension = GrepExtensionName(tmp1);
           extdomain = true;
           p.FullDomainName = GrepHostName(tmp1);
           p.DomainName = GrepCNameName(tmp1);  
       }
       
       if (tmp1.size() > 1 && extdomain && !tmp1.contains(".")) {
           p.DomainName = tmp1; 
           p.FullDomainName = GrepHostName(tmp1+"."+p.DomainExtension);
       }
       
       if (extdomain) {
       //////std::cout << "p.FullDomainName.- " << qPrintable(p.FullDomainName) << std::endl;
       //////////std::cout << "p.DomainExtension." << qPrintable(p.DomainExtension) << std::endl;
      /////////std::cout << "p.DomainName.- " << qPrintable(p.DomainName) << std::endl;  
       }
       
       if (mastermake.size() > 1) {
           tmp1 = mastermake.join("|");
           if (tmp1.contains("|SOA|")) {
               tmp2 = tmp1.mid(tmp1.indexOf("|SOA|"));
               tmp2 = tmp2.replace("|SOA|","");
               std::cout << "tmp2 " << qPrintable(tmp2) << std::endl;
               QStringList maildmaster = tmp2.split(" ",QString::SkipEmptyParts);
               std::cout << "maildmaster.size() " << maildmaster.size() << std::endl;
               if (maildmaster.size() > 0) {
               p.Mailtech = CleanName(maildmaster.last());
               p.Masterdns = CleanName(maildmaster.first());
               dmail = QString(p.Mailtech);
               int dotfirst = dmail.indexOf(".");
               dmail = dmail.replace(dotfirst,dotfirst-3,"@");  
               p.Mailtech = dmail;
               }
               
               
           } else {
               tmp1 = mailinfo.replace("\t","|");
               if (tmp1.contains("|SOA")) {
               tmp2 = tmp1.mid(tmp1.indexOf("|SOA"));
               tmp2 = tmp2.replace("|SOA","");
               QStringList maildmaster = tmp2.split(" ",QString::SkipEmptyParts);
               //////std::cout << "mailinfo0 " << qPrintable(tmp2) << std::endl; 
                   if (maildmaster.size() > 0) {
                   p.Mailtech = CleanName(maildmaster.last());
                   p.Masterdns = CleanName(maildmaster.first());
                   dmail = QString(p.Mailtech);
                   int dotfirst = dmail.indexOf(".");
                   dmail = dmail.replace(dotfirst,dotfirst-3,"@");  
                   p.Mailtech = dmail;
                   }
               }
               
               
           }
         /////////std::cout << "mastermake " << qPrintable(dmail) << std::endl; 
       } else {
           /////////////std::cout << "mailinfo " << qPrintable(mailinfo) << std::endl; 
           
       }
       
       
       if (dmail.size() < 1) {
        dmail =   QString("unknow@%1").arg(p.FullDomainName);  
       }
       
       if (p.Masterdns.size() < 1) {
        p.Masterdns = QString("notfound_ns_soa.%1").arg(p.FullDomainName);  
       }
       

         
       
          ////////////std::cout << qPrintable(p.FullDomainName) << std::endl;
       
       
               p.LineInfo = AccLine;
               
               
               
               if (p.DomainName != "#_error_error_#" && p.DomainExtension !="") {
               //////////std::cout << "Soa Line nnnnn ->" << qPrintable(p.FullDomainName) << std::endl;
               DNS_Item *dnso = new DNS_Item(p);
               emit OkJobEnd(dnso);
               exit(0);
               return; 
               } else {
                ///////std::cout << "ERROR ############### Soa Line->" << qPrintable(SOALine) << std::endl;
                 emit ErrorMsg(QString("e569 Unable to grep this SOA! \"%2\" on file %1").arg(GrepFromFile).arg(soares));
                 return; 
                exit(0);
               }
    
    
}

signals:
   void ErrorMsg(QString);
   void OkJobEnd(DNS_Item *);
private:
    QStringList AccLine;
    QString fi;
};




class Resolve : public QObject
{
     Q_OBJECT
//
public:
Resolve( const QString domain , DNS_Item * info );
protected:
    QStringList roundlist;
     DNS_Item *all;
private:
signals:
void SendIps(DNS_Item *);
public slots:
void lookedUp(const QHostInfo &host);
};
//
#endif // RESOLVE_H

